package org.ferris.journal.ejb.journal.junit.Journal;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import org.ferris.journal.ejb.journal.Journal;
import org.ferris.journal.ejb.lang.DomainException;
import org.ferris.journal.ejb.lang.DomainExceptionCode;
import org.junit.Test;

public class IsActive {

	@Test
	public void isActive() {
		Boolean t = Boolean.TRUE;
		Journal a = JournalFactory.getJournal();
		a.setIsActive(t);
		assertEquals(t, a.getIsActive());
	}
	
	@Test
	public void testGetId_WithNull() {
		DomainException caught = null;
		try {
			Journal a = JournalFactory.getJournal();
			a.setIsActive(null);
		} catch (DomainException e) {
			caught = e;
		}
		assertNotNull("DomainException not thrown", caught);
		assertEquals(DomainExceptionCode.DOMAIN00015, caught.getCode());
	}
}
