package org.ferris.journal.ejb.journal.junit.JournalEntryEjb;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import java.util.Date;

import org.ferris.journal.ejb.account.Account;
import org.ferris.journal.ejb.account.junit.Account.AccountFactory;
import org.ferris.journal.ejb.journal.Journal;
import org.ferris.journal.ejb.journal.JournalEntry;
import org.ferris.journal.ejb.journal.junit.Journal.JournalFactory;
import org.ferris.journal.ejb.lang.DomainException;
import org.ferris.journal.ejb.lang.DomainExceptionCode;
import org.junit.Test;

public class UpdateTest extends JournalEntryEjbTest
{
	@Test
	public void _passNull() {
		
		DomainException caught = null;
		try {
			getJournalEntryEjb().update(null);
		}
		catch (DomainException e) {
			caught = e;
		}
		assertNotNull("DomainException not thrown", caught);
		assertEquals(DomainExceptionCode.DOMAIN00038, caught.getCode());
	}
	
	@Test
	public void _() {
		Account a = AccountFactory.getAccount();
		a = getAccountEjb().insert(a);
		
		Journal j = JournalFactory.getJournal();
		j.setAccount(a);
		j.setCreatedOn(new Date());
		j.setIsActive(Boolean.TRUE);
		j.setName("mikey");
		j = getJournalEjb().insert(j);
		
		JournalEntry je = new JournalEntry();
		je.setAccount(a);
		je.setCreatedOn(new Date());
		je.setDay(new Date());
		je.setEntry("entry");
		je.setJournal(j);
		je.setSubject("subject");
		JournalEntry jeje = getJournalEntryEjb().insert(je);
		
		assertEquals("entry", jeje.getEntry());
		assertNotNull(jeje.getId());
		
		jeje.setEntry("wow");
		JournalEntry jejeje = getJournalEntryEjb().update(jeje);
		assertEquals(jeje.getId(), jejeje.getId());
		assertEquals("wow", jejeje.getEntry());
		
	}
}
